diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index 4a57947532e..3c348964d9b 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -55,16 +55,10 @@
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
-static const IDirectInput7AVtbl ddi7avt;
 static const IDirectInput7WVtbl ddi7wvt;
 static const IDirectInput8WVtbl ddi8wvt;
 static const IDirectInputJoyConfig8Vtbl JoyConfig8vt;
 
-static inline IDirectInputImpl *impl_from_IDirectInput7A( IDirectInput7A *iface )
-{
-    return CONTAINING_RECORD( iface, IDirectInputImpl, IDirectInput7A_iface );
-}
-
 static inline IDirectInputImpl *impl_from_IDirectInput7W( IDirectInput7W *iface )
 {
     return CONTAINING_RECORD( iface, IDirectInputImpl, IDirectInput7W_iface );
@@ -136,7 +130,7 @@ static HRESULT create_directinput_instance(REFIID riid, LPVOID *ppDI, IDirectInp
     if (!This)
         return E_OUTOFMEMORY;
 
-    This->IDirectInput7A_iface.lpVtbl = &ddi7avt;
+    This->IDirectInput7A_iface.lpVtbl = &direct_input_7_a_vtbl;
     This->IDirectInput7W_iface.lpVtbl = &ddi7wvt;
     This->IDirectInput8A_iface.lpVtbl = &direct_input_8_a_vtbl;
     This->IDirectInput8W_iface.lpVtbl = &ddi8wvt;
@@ -361,47 +355,6 @@ __ASM_GLOBAL_FUNC( enum_callback_wrapper,
 #define enum_callback_wrapper(callback, instance, ref) (callback)((instance), (ref))
 #endif
 
-/******************************************************************************
- *	IDirectInputA_EnumDevices
- */
-static HRESULT WINAPI IDirectInputAImpl_EnumDevices(
-	LPDIRECTINPUT7A iface, DWORD dwDevType, LPDIENUMDEVICESCALLBACKA lpCallback,
-	LPVOID pvRef, DWORD dwFlags)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
-    DIDEVICEINSTANCEA devInstance;
-    unsigned int i;
-    int j;
-    HRESULT r;
-
-    TRACE("(this=%p,0x%04x '%s',%p,%p,0x%04x)\n",
-	  This, dwDevType, _dump_DIDEVTYPE_value(dwDevType, This->dwVersion),
-	  lpCallback, pvRef, dwFlags);
-    _dump_EnumDevices_dwFlags(dwFlags);
-
-    if (!lpCallback ||
-        dwFlags & ~(DIEDFL_ATTACHEDONLY | DIEDFL_FORCEFEEDBACK | DIEDFL_INCLUDEALIASES | DIEDFL_INCLUDEPHANTOMS | DIEDFL_INCLUDEHIDDEN) ||
-        (dwDevType > DI8DEVCLASS_GAMECTRL && dwDevType < DI8DEVTYPE_DEVICE) || dwDevType > DI8DEVTYPE_SUPPLEMENTAL)
-        return DIERR_INVALIDPARAM;
-
-    if (!This->initialized)
-        return DIERR_NOTINITIALIZED;
-
-    for (i = 0; i < ARRAY_SIZE(dinput_devices); i++) {
-        if (!dinput_devices[i]->enum_deviceA) continue;
-
-        TRACE(" Checking device %u ('%s')\n", i, dinput_devices[i]->name);
-        for (j = 0, r = S_OK; SUCCEEDED(r); j++) {
-            devInstance.dwSize = sizeof(devInstance);
-            r = dinput_devices[i]->enum_deviceA(dwDevType, dwFlags, &devInstance, This->dwVersion, j);
-            if (r == S_OK)
-                if (enum_callback_wrapper(lpCallback, &devInstance, pvRef) == DIENUM_STOP)
-                    return S_OK;
-        }
-    }
-
-    return S_OK;
-}
 /******************************************************************************
  *	IDirectInputW_EnumDevices
  */
@@ -443,24 +396,18 @@ static HRESULT WINAPI IDirectInputWImpl_EnumDevices(
     return S_OK;
 }
 
-static ULONG WINAPI IDirectInputAImpl_AddRef(LPDIRECTINPUT7A iface)
+static ULONG WINAPI IDirectInputWImpl_AddRef(LPDIRECTINPUT7W iface)
 {
-    IDirectInputImpl *This = impl_from_IDirectInput7A( iface );
+    IDirectInputImpl *This = impl_from_IDirectInput7W(iface);
     ULONG ref = InterlockedIncrement(&This->ref);
 
     TRACE( "(%p) ref %d\n", This, ref );
     return ref;
 }
 
-static ULONG WINAPI IDirectInputWImpl_AddRef(LPDIRECTINPUT7W iface)
+static ULONG WINAPI IDirectInputWImpl_Release(LPDIRECTINPUT7W iface)
 {
     IDirectInputImpl *This = impl_from_IDirectInput7W( iface );
-    return IDirectInputAImpl_AddRef( &This->IDirectInput7A_iface );
-}
-
-static ULONG WINAPI IDirectInputAImpl_Release(LPDIRECTINPUT7A iface)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput7A( iface );
     ULONG ref = InterlockedDecrement( &This->ref );
 
     TRACE( "(%p) ref %d\n", This, ref );
@@ -474,15 +421,9 @@ static ULONG WINAPI IDirectInputAImpl_Release(LPDIRECTINPUT7A iface)
     return ref;
 }
 
-static ULONG WINAPI IDirectInputWImpl_Release(LPDIRECTINPUT7W iface)
+static HRESULT WINAPI IDirectInputWImpl_QueryInterface(LPDIRECTINPUT7W iface, REFIID riid, LPVOID *ppobj)
 {
     IDirectInputImpl *This = impl_from_IDirectInput7W( iface );
-    return IDirectInputAImpl_Release( &This->IDirectInput7A_iface );
-}
-
-static HRESULT WINAPI IDirectInputAImpl_QueryInterface(LPDIRECTINPUT7A iface, REFIID riid, LPVOID *ppobj)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput7A( iface );
 
     TRACE( "(%p)->(%s,%p)\n", This, debugstr_guid(riid), ppobj );
 
@@ -525,12 +466,6 @@ static HRESULT WINAPI IDirectInputAImpl_QueryInterface(LPDIRECTINPUT7A iface, RE
     return E_NOINTERFACE;
 }
 
-static HRESULT WINAPI IDirectInputWImpl_QueryInterface(LPDIRECTINPUT7W iface, REFIID riid, LPVOID *ppobj)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput7W( iface );
-    return IDirectInputAImpl_QueryInterface( &This->IDirectInput7A_iface, riid, ppobj );
-}
-
 static LRESULT WINAPI di_em_win_wndproc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
 {
     IDirectInputDeviceImpl *dev;
@@ -634,9 +569,9 @@ enum directinput_versions
     DIRECTINPUT_VERSION_700 = 0x0700,
 };
 
-static HRESULT WINAPI IDirectInputAImpl_Initialize(LPDIRECTINPUT7A iface, HINSTANCE hinst, DWORD version)
+static HRESULT WINAPI IDirectInputWImpl_Initialize(LPDIRECTINPUT7W iface, HINSTANCE hinst, DWORD version)
 {
-    IDirectInputImpl *This = impl_from_IDirectInput7A( iface );
+    IDirectInputImpl *This = impl_from_IDirectInput7W(iface);
 
     TRACE("(%p)->(%p, 0x%04x)\n", This, hinst, version);
 
@@ -655,17 +590,11 @@ static HRESULT WINAPI IDirectInputAImpl_Initialize(LPDIRECTINPUT7A iface, HINSTA
     return initialize_directinput_instance(This, version);
 }
 
-static HRESULT WINAPI IDirectInputWImpl_Initialize(LPDIRECTINPUT7W iface, HINSTANCE hinst, DWORD x)
+static HRESULT WINAPI IDirectInputWImpl_GetDeviceStatus(LPDIRECTINPUT7W iface, REFGUID rguid)
 {
     IDirectInputImpl *This = impl_from_IDirectInput7W( iface );
-    return IDirectInputAImpl_Initialize( &This->IDirectInput7A_iface, hinst, x );
-}
-
-static HRESULT WINAPI IDirectInputAImpl_GetDeviceStatus(LPDIRECTINPUT7A iface, REFGUID rguid)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput7A( iface );
     HRESULT hr;
-    LPDIRECTINPUTDEVICEA device;
+    LPDIRECTINPUTDEVICEW device;
 
     TRACE( "(%p)->(%s)\n", This, debugstr_guid(rguid) );
 
@@ -681,22 +610,13 @@ static HRESULT WINAPI IDirectInputAImpl_GetDeviceStatus(LPDIRECTINPUT7A iface, R
     return DI_OK;
 }
 
-static HRESULT WINAPI IDirectInputWImpl_GetDeviceStatus(LPDIRECTINPUT7W iface, REFGUID rguid)
+static HRESULT WINAPI IDirectInputWImpl_RunControlPanel(LPDIRECTINPUT7W iface, HWND hwndOwner, DWORD dwFlags)
 {
     IDirectInputImpl *This = impl_from_IDirectInput7W( iface );
-    return IDirectInputAImpl_GetDeviceStatus( &This->IDirectInput7A_iface, rguid );
-}
-
-static HRESULT WINAPI IDirectInputAImpl_RunControlPanel(LPDIRECTINPUT7A iface,
-							HWND hwndOwner,
-							DWORD dwFlags)
-{
     WCHAR control_exeW[] = {'c','o','n','t','r','o','l','.','e','x','e',0};
     STARTUPINFOW si = {0};
     PROCESS_INFORMATION pi;
 
-    IDirectInputImpl *This = impl_from_IDirectInput7A( iface );
-
     TRACE( "(%p)->(%p, %08x)\n", This, hwndOwner, dwFlags );
 
     if (hwndOwner && !IsWindow(hwndOwner))
@@ -714,22 +634,6 @@ static HRESULT WINAPI IDirectInputAImpl_RunControlPanel(LPDIRECTINPUT7A iface,
     return DI_OK;
 }
 
-static HRESULT WINAPI IDirectInputWImpl_RunControlPanel(LPDIRECTINPUT7W iface, HWND hwndOwner, DWORD dwFlags)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput7W( iface );
-    return IDirectInputAImpl_RunControlPanel( &This->IDirectInput7A_iface, hwndOwner, dwFlags );
-}
-
-static HRESULT WINAPI IDirectInput2AImpl_FindDevice(LPDIRECTINPUT7A iface, REFGUID rguid,
-						    LPCSTR pszName, LPGUID pguidInstance)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput7A( iface );
-
-    FIXME( "(%p)->(%s, %s, %p): stub\n", This, debugstr_guid(rguid), pszName, pguidInstance );
-
-    return DI_OK;
-}
-
 static HRESULT WINAPI IDirectInput2WImpl_FindDevice(LPDIRECTINPUT7W iface, REFGUID rguid,
 						    LPCWSTR pszName, LPGUID pguidInstance)
 {
@@ -740,11 +644,15 @@ static HRESULT WINAPI IDirectInput2WImpl_FindDevice(LPDIRECTINPUT7W iface, REFGU
     return DI_OK;
 }
 
-static HRESULT create_device(IDirectInputImpl *This, REFGUID rguid, REFIID riid, LPVOID *pvOut)
+static HRESULT WINAPI IDirectInput7WImpl_CreateDeviceEx(LPDIRECTINPUT7W iface, REFGUID rguid, REFIID riid,
+        LPVOID *pvOut, LPUNKNOWN lpUnknownOuter)
 {
+    IDirectInputImpl *This = impl_from_IDirectInput7W(iface);
     unsigned int i;
     HRESULT hr;
 
+    TRACE("(%p)->(%s, %s, %p, %p)\n", This, debugstr_guid(rguid), debugstr_guid(riid), pvOut, lpUnknownOuter);
+
     if (pvOut)
         *pvOut = NULL;
 
@@ -764,32 +672,6 @@ static HRESULT create_device(IDirectInputImpl *This, REFGUID rguid, REFIID riid,
     return DIERR_DEVICENOTREG;
 }
 
-static HRESULT WINAPI IDirectInput7AImpl_CreateDeviceEx(LPDIRECTINPUT7A iface, REFGUID rguid,
-                                                        REFIID riid, LPVOID* pvOut, LPUNKNOWN lpUnknownOuter)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput7A( iface );
-
-    TRACE("(%p)->(%s, %s, %p, %p)\n", This, debugstr_guid(rguid), debugstr_guid(riid), pvOut, lpUnknownOuter);
-
-    return create_device(This, rguid, riid, pvOut);
-}
-
-static HRESULT WINAPI IDirectInput7WImpl_CreateDeviceEx(LPDIRECTINPUT7W iface, REFGUID rguid,
-                                                        REFIID riid, LPVOID* pvOut, LPUNKNOWN lpUnknownOuter)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput7W( iface );
-
-    TRACE("(%p)->(%s, %s, %p, %p)\n", This, debugstr_guid(rguid), debugstr_guid(riid), pvOut, lpUnknownOuter);
-
-    return create_device(This, rguid, riid, pvOut);
-}
-
-static HRESULT WINAPI IDirectInputAImpl_CreateDevice(LPDIRECTINPUT7A iface, REFGUID rguid,
-                                                     LPDIRECTINPUTDEVICEA* pdev, LPUNKNOWN punk)
-{
-    return IDirectInput7AImpl_CreateDeviceEx(iface, rguid, &IID_IDirectInputDeviceA, (LPVOID *)pdev, punk);
-}
-
 static HRESULT WINAPI IDirectInputWImpl_CreateDevice(LPDIRECTINPUT7W iface, REFGUID rguid,
                                                      LPDIRECTINPUTDEVICEW* pdev, LPUNKNOWN punk)
 {
@@ -1175,19 +1057,6 @@ static HRESULT WINAPI JoyConfig8Impl_OpenAppStatusKey(IDirectInputJoyConfig8 *if
     return E_NOTIMPL;
 }
 
-static const IDirectInput7AVtbl ddi7avt = {
-    IDirectInputAImpl_QueryInterface,
-    IDirectInputAImpl_AddRef,
-    IDirectInputAImpl_Release,
-    IDirectInputAImpl_CreateDevice,
-    IDirectInputAImpl_EnumDevices,
-    IDirectInputAImpl_GetDeviceStatus,
-    IDirectInputAImpl_RunControlPanel,
-    IDirectInputAImpl_Initialize,
-    IDirectInput2AImpl_FindDevice,
-    IDirectInput7AImpl_CreateDeviceEx
-};
-
 static const IDirectInput7WVtbl ddi7wvt = {
     IDirectInputWImpl_QueryInterface,
     IDirectInputWImpl_AddRef,
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index 07be7b2dd8d..31166539da8 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -49,6 +49,7 @@ struct IDirectInputImpl
     struct list                 device_players; /* device instance guid to player name */
 };
 
+extern const IDirectInput7AVtbl direct_input_7_a_vtbl DECLSPEC_HIDDEN;
 extern const IDirectInput8AVtbl direct_input_8_a_vtbl DECLSPEC_HIDDEN;
 
 typedef struct IDirectInputDeviceImpl IDirectInputDeviceImpl;
-- 
2.28.0

>From 6e5665d2804421f9349376da3b14a97f9167c9c0 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 08/39] dinput: Introduce dinput_enum_device helper.

To wrap enum_deviceA/W calls, so that only one of the two is needed.
Unix devices won't be able to handle WCHAR easily.
---
 dlls/dinput/ansi.c           | 25 +++++++++++++++++++++++++
 dlls/dinput/dinput_main.c    | 14 ++++----------
 dlls/dinput/dinput_private.h |  2 ++
 3 files changed, 31 insertions(+), 10 deletions(-)

diff --git a/dlls/dinput/ansi.c b/dlls/dinput/ansi.c
index a3d49802b7c..81ac24f4d26 100644
--- a/dlls/dinput/ansi.c
+++ b/dlls/dinput/ansi.c
@@ -103,6 +103,19 @@ static void dideviceinstance_wtoa(const DIDEVICEINSTANCEW *didiw, DIDEVICEINSTAN
     didia->wUsage = didiw->wUsage;
 }
 
+static void dideviceinstance_atow(const DIDEVICEINSTANCEA *didia, DIDEVICEINSTANCEW *didiw)
+{
+    didiw->guidInstance = didia->guidInstance;
+    didiw->guidProduct = didia->guidProduct;
+    didiw->dwDevType = didia->dwDevType;
+    MultiByteToWideChar(CP_ACP, 0, didia->tszInstanceName, -1, didiw->tszInstanceName, sizeof(didiw->tszInstanceName));
+    MultiByteToWideChar(CP_ACP, 0, didia->tszProductName, -1, didiw->tszProductName, sizeof(didiw->tszProductName));
+    if (didiw->dwSize <= FIELD_OFFSET(DIDEVICEINSTANCEW, guidFFDriver)) return;
+    didiw->guidFFDriver = didia->guidFFDriver;
+    didiw->wUsagePage = didia->wUsagePage;
+    didiw->wUsage = didia->wUsage;
+}
+
 static void dieffectinfo_wtoa(const DIEFFECTINFOW *dieiw, DIEFFECTINFOA *dieia)
 {
     dieia->guid = dieiw->guid;
@@ -890,3 +903,15 @@ const IDirectInput7AVtbl direct_input_7_a_vtbl =
     /*** IDirectInput7A methods ***/
     direct_input_7_a_CreateDeviceEx,
 };
+
+HRESULT dinput_enum_device(const struct dinput_device *device, DWORD type, DWORD flags, DIDEVICEINSTANCEW *didi,
+        DWORD version, int index)
+{
+    DIDEVICEINSTANCEA didia = {sizeof(didia)};
+    HRESULT hr;
+    if (device->enum_deviceW) return device->enum_deviceW(type, flags, didi, version, index);
+    if (!device->enum_deviceA) return E_FAIL;
+    hr = device->enum_deviceA(type, flags, &didia, version, index);
+    dideviceinstance_atow(&didia, didi);
+    return hr;
+}
diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index 3c348964d9b..42832b8d715 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -382,11 +382,10 @@ static HRESULT WINAPI IDirectInputWImpl_EnumDevices(
         return DIERR_NOTINITIALIZED;
 
     for (i = 0; i < ARRAY_SIZE(dinput_devices); i++) {
-        if (!dinput_devices[i]->enum_deviceW) continue;
         for (j = 0, r = S_OK; SUCCEEDED(r); j++) {
             devInstance.dwSize = sizeof(devInstance);
             TRACE("  - checking device %u ('%s')\n", i, dinput_devices[i]->name);
-            r = dinput_devices[i]->enum_deviceW(dwDevType, dwFlags, &devInstance, This->dwVersion, j);
+            r = dinput_enum_device(dinput_devices[i], dwDevType, dwFlags, &devInstance, This->dwVersion, j);
             if (r == S_OK)
                 if (enum_callback_wrapper(lpCallback, &devInstance, pvRef) == DIENUM_STOP)
                     return S_OK;
@@ -817,15 +816,12 @@ static HRESULT WINAPI IDirectInput8WImpl_EnumDevicesBySemantics(
     for (i = 0; i < ARRAY_SIZE(dinput_devices); i++)
     {
         HRESULT enumSuccess;
-
-        if (!dinput_devices[i]->enum_deviceW) continue;
-
         for (j = 0, enumSuccess = S_OK; SUCCEEDED(enumSuccess); j++)
         {
             TRACE(" - checking device %u ('%s')\n", i, dinput_devices[i]->name);
 
             /* Default behavior is to enumerate attached game controllers */
-            enumSuccess = dinput_devices[i]->enum_deviceW(DI8DEVCLASS_GAMECTRL, DIEDFL_ATTACHEDONLY | dwFlags, &didevi, This->dwVersion, j);
+            enumSuccess = dinput_enum_device(dinput_devices[i], DI8DEVCLASS_GAMECTRL, DIEDFL_ATTACHEDONLY | dwFlags, &didevi, This->dwVersion, j);
             if (enumSuccess == S_OK &&
                 should_enumerate_device(ptszUserName, dwFlags, &This->device_players, &didevi.guidInstance))
             {
@@ -991,13 +987,11 @@ static HRESULT WINAPI JoyConfig8Impl_GetConfig(IDirectInputJoyConfig8 *iface, UI
     /* Enumerate all joysticks in order */
     for (i = 0; i < ARRAY_SIZE(dinput_devices); i++)
     {
-        if (!dinput_devices[i]->enum_deviceA) continue;
-
         for (j = 0, r = S_OK; SUCCEEDED(r); j++)
         {
-            DIDEVICEINSTANCEA dev;
+            DIDEVICEINSTANCEW dev;
             dev.dwSize = sizeof(dev);
-            if ((r = dinput_devices[i]->enum_deviceA(DI8DEVCLASS_GAMECTRL, 0, &dev, di->dwVersion, j)) == S_OK)
+            if ((r = dinput_enum_device(dinput_devices[i], DI8DEVCLASS_GAMECTRL, 0, &dev, di->dwVersion, j)) == S_OK)
             {
                 /* Only take into account the chosen id */
                 if (found == id)
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index 31166539da8..472f21adb1b 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -64,6 +64,8 @@ struct dinput_device {
 
 extern HRESULT dinput_create_device(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid,
         REFIID iid, void **out) DECLSPEC_HIDDEN;
+extern HRESULT dinput_enum_device(const struct dinput_device *device, DWORD type, DWORD flags, DIDEVICEINSTANCEW *didi,
+        DWORD version, int index) DECLSPEC_HIDDEN;
 
 struct DevicePlayer {
     GUID instance_guid;
-- 
2.28.0

>From a733b44aba29cf83698d00601054d5cb1cf8ed7e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 09/39] dinput: Remove enum_deviceW from unix devices.

And enum_deviceA from Win32 devices.
---
 dlls/dinput/joystick_linux.c      | 31 +-----------------
 dlls/dinput/joystick_linuxinput.c | 27 +---------------
 dlls/dinput/joystick_osx.c        | 52 +------------------------------
 dlls/dinput/keyboard.c            | 47 +---------------------------
 dlls/dinput/mouse.c               | 47 +---------------------------
 5 files changed, 5 insertions(+), 199 deletions(-)

diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index efec79962dd..0386bfa77e9 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -421,35 +421,6 @@ static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINS
     return S_FALSE;
 }
 
-static HRESULT joydev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
-{
-    int fd = -1;
-
-    if (id >= find_joystick_devices()) return E_FAIL;
-
-    if (dwFlags & DIEDFL_FORCEFEEDBACK) {
-        WARN("force feedback not supported\n");
-        return S_FALSE;
-    }
-
-    if ((dwDevType == 0) ||
-	((dwDevType == DIDEVTYPE_JOYSTICK) && (version >= 0x0300 && version < 0x0800)) ||
-	(((dwDevType == DI8DEVCLASS_GAMECTRL) || (dwDevType == DI8DEVTYPE_JOYSTICK)) && (version >= 0x0800))) {
-        /* check whether we have a joystick */
-        if ((fd = open(joystick_devices[id].device, O_RDONLY)) == -1)
-        {
-            WARN("open(%s, O_RDONLY) failed: %s\n", joystick_devices[id].device, strerror(errno));
-            return S_FALSE;
-        }
-        fill_joystick_dideviceinstanceW( lpddi, version, id );
-        close(fd);
-        TRACE("Enumerating the linux Joystick device: %s (%s)\n", joystick_devices[id].device, joystick_devices[id].name);
-        return S_OK;
-    }
-
-    return S_FALSE;
-}
-
 static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
                             JoystickImpl **pdev, unsigned short index)
 {
@@ -613,7 +584,7 @@ static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDir
 const struct dinput_device joystick_linux_device = {
   "Wine Linux joystick driver",
   joydev_enum_deviceA,
-  joydev_enum_deviceW,
+  NULL,
   joydev_create_device
 };
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 1c095b27c6c..c34a73ec4e0 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -419,31 +419,6 @@ static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINS
   return S_FALSE;
 }
 
-static HRESULT joydev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
-{
-  find_joydevs();
-
-  if (id >= have_joydevs) {
-    return E_FAIL;
-  }
-
-  if (!((dwDevType == 0) ||
-        ((dwDevType == DIDEVTYPE_JOYSTICK) && (version >= 0x0300 && version < 0x0800)) ||
-        (((dwDevType == DI8DEVCLASS_GAMECTRL) || (dwDevType == DI8DEVTYPE_JOYSTICK)) && (version >= 0x0800))))
-    return S_FALSE;
-
-#ifndef HAVE_STRUCT_FF_EFFECT_DIRECTION
-  if (dwFlags & DIEDFL_FORCEFEEDBACK)
-    return S_FALSE;
-#endif
-
-  if (!(dwFlags & DIEDFL_FORCEFEEDBACK) || joydevs[id].has_ff) {
-    fill_joystick_dideviceinstanceW(lpddi, version, id);
-    return S_OK;
-  }
-  return S_FALSE;
-}
-
 static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsigned short index)
 {
     JoystickImpl* newDevice;
@@ -631,7 +606,7 @@ static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDir
 const struct dinput_device joystick_linuxinput_device = {
   "Wine Linux-input joystick driver",
   joydev_enum_deviceA,
-  joydev_enum_deviceW,
+  NULL,
   joydev_create_device
 };
 
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 347e76a7bc4..def374d047d 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -995,56 +995,6 @@ static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINS
     return S_FALSE;
 }
 
-static HRESULT joydev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
-{
-    char name[MAX_PATH];
-    char friendly[32];
-    IOHIDDeviceRef device;
-    BOOL is_joystick;
-
-    TRACE("dwDevType %u dwFlags 0x%08x version 0x%04x id %d\n", dwDevType, dwFlags, version, id);
-
-    if (id >= find_joystick_devices()) return E_FAIL;
-
-    device = get_device_ref(id);
-
-    if ((dwDevType == 0) ||
-    ((dwDevType == DIDEVTYPE_JOYSTICK) && (version >= 0x0300 && version < 0x0800)) ||
-    (((dwDevType == DI8DEVCLASS_GAMECTRL) || (dwDevType == DI8DEVTYPE_JOYSTICK)) && (version >= 0x0800))) {
-
-        if (dwFlags & DIEDFL_FORCEFEEDBACK) {
-            if(!device)
-                return S_FALSE;
-            if(get_ff(device, NULL) != S_OK)
-                return S_FALSE;
-        }
-        is_joystick = get_device_property_long(device, CFSTR(kIOHIDDeviceUsageKey)) == kHIDUsage_GD_Joystick;
-        /* Return joystick */
-        lpddi->guidInstance = DInput_Wine_OsX_Joystick_GUID;
-        lpddi->guidInstance.Data3 = id;
-        lpddi->guidProduct = DInput_PIDVID_Product_GUID;
-        lpddi->guidProduct.Data1 = make_vid_pid(device);
-        lpddi->dwDevType = get_device_type(version, is_joystick);
-        lpddi->dwDevType |= DIDEVTYPE_HID;
-        lpddi->wUsagePage = 0x01; /* Desktop */
-        if (is_joystick)
-            lpddi->wUsage = 0x04; /* Joystick */
-        else
-            lpddi->wUsage = 0x05; /* Game Pad */
-        sprintf(friendly, "Joystick %d", id);
-        MultiByteToWideChar(CP_ACP, 0, friendly, -1, lpddi->tszInstanceName, MAX_PATH);
-
-        /* get the device name */
-        get_osx_device_name(id, name, MAX_PATH);
-
-        MultiByteToWideChar(CP_ACP, 0, name, -1, lpddi->tszProductName, MAX_PATH);
-        lpddi->guidFFDriver = GUID_NULL;
-        return S_OK;
-    }
-
-    return S_FALSE;
-}
-
 static const char *osx_ff_axis_name(UInt8 axis)
 {
     static char ret[6];
@@ -1469,7 +1419,7 @@ static HRESULT WINAPI JoystickWImpl_SendForceFeedbackCommand(IDirectInputDevice8
 const struct dinput_device joystick_osx_device = {
   "Wine OS X joystick driver",
   joydev_enum_deviceA,
-  joydev_enum_deviceW,
+  NULL,
   joydev_create_device
 };
 
diff --git a/dlls/dinput/keyboard.c b/dlls/dinput/keyboard.c
index ae4a675aec7..57e057cfbe7 100644
--- a/dlls/dinput/keyboard.c
+++ b/dlls/dinput/keyboard.c
@@ -149,30 +149,6 @@ static DWORD get_keyboard_subtype(void)
     return dev_subtype;
 }
 
-static void fill_keyboard_dideviceinstanceA(LPDIDEVICEINSTANCEA lpddi, DWORD version, DWORD subtype) {
-    DWORD dwSize;
-    DIDEVICEINSTANCEA ddi;
-    
-    dwSize = lpddi->dwSize;
-
-    TRACE("%d %p\n", dwSize, lpddi);
-    
-    memset(lpddi, 0, dwSize);
-    memset(&ddi, 0, sizeof(ddi));
-
-    ddi.dwSize = dwSize;
-    ddi.guidInstance = GUID_SysKeyboard;/* DInput's GUID */
-    ddi.guidProduct = GUID_SysKeyboard;
-    if (version >= 0x0800)
-        ddi.dwDevType = DI8DEVTYPE_KEYBOARD | (subtype << 8);
-    else
-        ddi.dwDevType = DIDEVTYPE_KEYBOARD | (subtype << 8);
-    strcpy(ddi.tszInstanceName, "Keyboard");
-    strcpy(ddi.tszProductName, "Wine Keyboard");
-
-    memcpy(lpddi, &ddi, (dwSize < sizeof(ddi) ? dwSize : sizeof(ddi)));
-}
-
 static void fill_keyboard_dideviceinstanceW(LPDIDEVICEINSTANCEW lpddi, DWORD version, DWORD subtype) {
     DWORD dwSize;
     DIDEVICEINSTANCEW ddi;
@@ -197,27 +173,6 @@ static void fill_keyboard_dideviceinstanceW(LPDIDEVICEINSTANCEW lpddi, DWORD ver
     memcpy(lpddi, &ddi, (dwSize < sizeof(ddi) ? dwSize : sizeof(ddi)));
 }
  
-static HRESULT keyboarddev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
-{
-  if (id != 0)
-    return E_FAIL;
-
-  if (dwFlags & DIEDFL_FORCEFEEDBACK)
-    return S_FALSE;
-
-  if ((dwDevType == 0) ||
-      ((dwDevType == DIDEVTYPE_KEYBOARD) && (version < 0x0800)) ||
-      (((dwDevType == DI8DEVCLASS_KEYBOARD) || (dwDevType == DI8DEVTYPE_KEYBOARD)) && (version >= 0x0800))) {
-    TRACE("Enumerating the Keyboard device\n");
- 
-    fill_keyboard_dideviceinstanceA(lpddi, version, get_keyboard_subtype());
-    
-    return S_OK;
-  }
-
-  return S_FALSE;
-}
-
 static HRESULT keyboarddev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
 {
   if (id != 0)
@@ -299,7 +254,7 @@ static HRESULT keyboarddev_create_device(IDirectInputImpl *dinput, REFGUID guid,
 
 const struct dinput_device keyboard_device = {
   "Wine keyboard driver",
-  keyboarddev_enum_deviceA,
+  NULL,
   keyboarddev_enum_deviceW,
   keyboarddev_create_device
 };
diff --git a/dlls/dinput/mouse.c b/dlls/dinput/mouse.c
index 06255bdafe5..608f8392925 100644
--- a/dlls/dinput/mouse.c
+++ b/dlls/dinput/mouse.c
@@ -93,30 +93,6 @@ static void _dump_mouse_state(const DIMOUSESTATE2 *m_state)
     TRACE(")\n");
 }
 
-static void fill_mouse_dideviceinstanceA(LPDIDEVICEINSTANCEA lpddi, DWORD version) {
-    DWORD dwSize;
-    DIDEVICEINSTANCEA ddi;
-    
-    dwSize = lpddi->dwSize;
-
-    TRACE("%d %p\n", dwSize, lpddi);
-    
-    memset(lpddi, 0, dwSize);
-    memset(&ddi, 0, sizeof(ddi));
-
-    ddi.dwSize = dwSize;
-    ddi.guidInstance = GUID_SysMouse;/* DInput's GUID */
-    ddi.guidProduct = GUID_SysMouse;
-    if (version >= 0x0800)
-        ddi.dwDevType = DI8DEVTYPE_MOUSE | (DI8DEVTYPEMOUSE_TRADITIONAL << 8);
-    else
-        ddi.dwDevType = DIDEVTYPE_MOUSE | (DIDEVTYPEMOUSE_TRADITIONAL << 8);
-    strcpy(ddi.tszInstanceName, "Mouse");
-    strcpy(ddi.tszProductName, "Wine Mouse");
-
-    memcpy(lpddi, &ddi, (dwSize < sizeof(ddi) ? dwSize : sizeof(ddi)));
-}
-
 static void fill_mouse_dideviceinstanceW(LPDIDEVICEINSTANCEW lpddi, DWORD version) {
     DWORD dwSize;
     DIDEVICEINSTANCEW ddi;
@@ -141,27 +117,6 @@ static void fill_mouse_dideviceinstanceW(LPDIDEVICEINSTANCEW lpddi, DWORD versio
     memcpy(lpddi, &ddi, (dwSize < sizeof(ddi) ? dwSize : sizeof(ddi)));
 }
 
-static HRESULT mousedev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
-{
-    if (id != 0)
-        return E_FAIL;
-
-    if (dwFlags & DIEDFL_FORCEFEEDBACK)
-        return S_FALSE;
-
-    if ((dwDevType == 0) ||
-	((dwDevType == DIDEVTYPE_MOUSE) && (version < 0x0800)) ||
-	(((dwDevType == DI8DEVCLASS_POINTER) || (dwDevType == DI8DEVTYPE_MOUSE)) && (version >= 0x0800))) {
-	TRACE("Enumerating the mouse device\n");
-	
-	fill_mouse_dideviceinstanceA(lpddi, version);
-	
-	return S_OK;
-    }
-    
-    return S_FALSE;
-}
-
 static HRESULT mousedev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
 {
     if (id != 0)
@@ -257,7 +212,7 @@ static HRESULT mousedev_create_device(IDirectInputImpl *dinput, REFGUID guid, ID
 
 const struct dinput_device mouse_device = {
     "Wine mouse driver",
-    mousedev_enum_deviceA,
+    NULL,
     mousedev_enum_deviceW,
     mousedev_create_device
 };
-- 
2.28.0

>From 0e65d2db721ab9087624e9baac8a1e3f9b579864 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 14:01:53 +0200
Subject: [PATCH 10/39] dinput: Check for registry disabled devices when
 enumerating.

---
 dlls/dinput/dinput_main.c         |  6 ++++++
 dlls/dinput/joystick.c            | 30 +++++++++++++++++++++---------
 dlls/dinput/joystick_linux.c      |  5 -----
 dlls/dinput/joystick_linuxinput.c |  8 --------
 dlls/dinput/joystick_private.h    |  2 +-
 5 files changed, 28 insertions(+), 23 deletions(-)

diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index 42832b8d715..43986029a50 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -51,6 +51,7 @@
 #include "devguid.h"
 #include "dinput_private.h"
 #include "device_private.h"
+#include "joystick_private.h"
 #include "dinputd.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
@@ -387,8 +388,11 @@ static HRESULT WINAPI IDirectInputWImpl_EnumDevices(
             TRACE("  - checking device %u ('%s')\n", i, dinput_devices[i]->name);
             r = dinput_enum_device(dinput_devices[i], dwDevType, dwFlags, &devInstance, This->dwVersion, j);
             if (r == S_OK)
+            {
+                if (device_disabled_registry(devInstance.tszProductName)) continue;
                 if (enum_callback_wrapper(lpCallback, &devInstance, pvRef) == DIENUM_STOP)
                     return S_OK;
+            }
         }
     }
 
@@ -825,6 +829,7 @@ static HRESULT WINAPI IDirectInput8WImpl_EnumDevicesBySemantics(
             if (enumSuccess == S_OK &&
                 should_enumerate_device(ptszUserName, dwFlags, &This->device_players, &didevi.guidInstance))
             {
+                if (device_disabled_registry(didevi.tszProductName)) continue;
                 if (device_count++)
                     didevis = HeapReAlloc(GetProcessHeap(), 0, didevis, sizeof(DIDEVICEINSTANCEW)*device_count);
                 else
@@ -993,6 +998,7 @@ static HRESULT WINAPI JoyConfig8Impl_GetConfig(IDirectInputJoyConfig8 *iface, UI
             dev.dwSize = sizeof(dev);
             if ((r = dinput_enum_device(dinput_devices[i], DI8DEVCLASS_GAMECTRL, 0, &dev, di->dwVersion, j)) == S_OK)
             {
+                if (device_disabled_registry(dev.tszProductName)) continue;
                 /* Only take into account the chosen id */
                 if (found == id)
                 {
